import 'package:flutter/material.dart';
import 'package:chapa/core/bank_transfer_manager/bank_transfer_payment_manager.dart';
import 'package:chapa/core/card_payment_manager/card_payment_manager.dart';
import 'package:chapa/core/mobile_money/mobile_money_payment_manager.dart';
import 'package:chapa/core/mpesa/mpesa_payment_manager.dart';
import 'package:chapa/core/pay_with_account_manager/bank_account_manager.dart';
import 'package:chapa/core/ussd_payment_manager/ussd_manager.dart';
import 'package:chapa/core/voucher_payment/voucher_payment_manager.dart';

class ChapaPaymentManager {
  String publicKey;
  String encryptionKey;
  String currency;
  String amount;
  String email;
  String fullName;
  String txRef;
  bool isDebugMode;
  String phoneNumber;
  bool acceptCardPayment;
  int? frequency;
  int? duration;
  bool? isPermanent;
  String? narration;
  String? network;
  String? country;
  String? redirectUrl;

  /// ChapaPaymentManager Constructor
  ChapaPaymentManager(
      {required this.publicKey,
      required this.encryptionKey,
      required this.currency,
      required this.amount,
      required this.email,
      required this.fullName,
      required this.txRef,
      required this.isDebugMode,
      required this.phoneNumber,
      this.country,
      this.acceptCardPayment = false,
      this.frequency,
      this.duration,
      this.isPermanent,
      this.narration,
      this.redirectUrl,
      this.network = ""});

  /// Returns an instance of CardPaymentManager
  CardPaymentManager getCardPaymentManager() {
    return CardPaymentManager(
        publicKey: this.publicKey,
        encryptionKey: this.encryptionKey,
        currency: this.currency,
        email: this.email,
        fullName: this.fullName,
        amount: this.amount,
        txRef: this.txRef,
        isDebugMode: this.isDebugMode,
        narration: this.narration,
        isPermanent: this.isPermanent,
        phoneNumber: this.phoneNumber,
        frequency: this.frequency,
        country: this.country,
        duration: this.duration,
        redirectUrl: this.redirectUrl);
  }

}
