class ValidateChargeRequest {
  String otp = "";
  String chpRef = "";
  bool isBankAccount = false;


  ValidateChargeRequest(this.otp, this.chpRef, [this.isBankAccount = false]);

  /// Initializes ValidateChargeRequest from json
  ValidateChargeRequest.fromJson(Map<String, dynamic> json) {
    this.otp = json["otp"];
    this.chpRef = json["chp_ref"];
    if(json["type"] != null) {
      this.isBankAccount = json["type"];
    } else {
      this.isBankAccount = false;
    }
  }

  /// Converts ValidateChargeRequest instance to json
  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data["otp"] = this.otp;
    data["chp_ref"] = this.chpRef;
    if (this.isBankAccount) {
      data["type"] = "account";
    }
    return data;
  }
}
