import 'package:chapa/core/chapa_error.dart';
import 'package:chapa/models/francophone_country.dart';
import 'package:chapa/utils/chapa_currency.dart';
import 'package:tripledes_nullsafety/tripledes_nullsafety.dart';

class ChapaUtils {
  
  /// Encrypts data using 3DES technology.
  /// Returns a String
  static String tripleDESEncrypt(dynamic data, String encryptionKey) {
    try {
      final blockCipher = BlockCipher(TripleDESEngine(), encryptionKey);
      return blockCipher.encodeB64(data);
    } catch (error) {
      throw(ChApaError("Unable to encrypt request"));
    }
  }

  /// Creates a card request with encrypted details
  /// Returns a map.
  static Map<String, String> createCardRequest(String encryptedData) {
    return {"client": encryptedData};
  }

}
